def Send(Device_Name,service_name,data):

    ##Ce programme permet l'envoie de donnée par bluetooth.
    ##Device_name : Nom de l'appareil auquel on souhaite envoyer des données. Le type est une chaine de charactère.
    ##service_name : Nom du service bluetoothe de l'appareil auquel on souhaite envoyer des données. Le type est une chaine de charactère.
    ##data : données que l'on souhaite envoyer. Le type est une chaine de charactère.
    
    import bluetooth

    #########Recherche les appareils autour, si l'un d'entre eux se nomme Device_Name--------------------------------------------------------------------------
 
    target_address = None #initialisation de l'adresse MAC cible

    nearby_devices = bluetooth.discover_devices(lookup_names=True) #Cherche les appareils à proximité ainsi que leurs noms
    
    for addr,name in nearby_devices:                                #si l'appareil est trouvé on donne son nom et son adresse MAC
        if name == Device_Name:                                     
            print("L'adresse de l'appareil %s est %s" % (name,addr))
            target_address = addr

    if target_address == None:      #Sinon "L'appareil n'a pas été trouvé"
        return("L'appareil n'a pas été trouvé")

    ##On recherche les services proposé par Device_Name--------------------------------------------------------------------------------------------------------

    port = -1 #On initialise le port à -1 car les ports bluetooth utilisable sont des entiers naturels 
    
    service= bluetooth.find_service(address=target_address) #On recherche tous les services proposé par l'appareil Device_name

    if len(service)==0:              #On vérifie que l'appareil à des services bluetooth disponible
        return("L'appareil ne propose aucun service")

    for svc in service:           #On cherche le service service_name qui nous permet de communiquer, ce service dépend de l'appareil récepteur 
        if svc["name"]==service_name:
            port = svc["port"]
            
    if port ==-1:      #On regarde si le service recherché existe, ci celui ci éxiste, il lui aura été attribué un port != 1
        return("l'appareil n'est pas prêt à se connecter")

    ##On établie la communication et envoie le message---------------------------------------------------------------------------------------------------------

    
    sock=bluetooth.BluetoothSocket(bluetooth.RFCOMM) #on initialise le serveur bluetooth
    sock.connect((target_address, port))    #on se connecte à l'addresse MAC et le port déterminé précédemment 
    sock.send(data)  #on envoie les données
    print("Le message %s a été envoyé" %data)
    sock.close #on ferme le serveur
    
    
    

    
    

    
    
    
        
