import tkinter as tk
from HMI_Veronica import *
from threading import Thread
from functools import partial



robot=HMI_Veronica()
count=robot.x_index


#PROGRAM_TEST
from random import *

Buffer_List=[False]


def wait():

    '''Gathers data after a given delay, test function for the program
       Inputs: None
       Outputs: None
       Author: FRESLIER Clément, 26/04/2020                                   '''


    i=0
    #External Variables
    Temp=-63                #Mars average temperature
    Hyg=25                  #Arbitrary value
    Pos=0                   #Position and Angle commands
    Ang=0

    while True:

        from time import sleep
        from datetime import datetime

        #position and angle, evolving linearly with random perturbation
        Pos+=i+uniform(-2,2)
        Ang+=(i/20+uniform(-3,3))
        if Ang>=360:
            Ang=0+uniform(-3,3)

        #wait time
        sleep(1)

        #date format
        date=datetime.now()
        date_fmt=date.strftime("%Y/%m/%d %H:%M:%S")

        #data list
        Buffer_List[0:0]=["%.1f" % Pos,"%.1f" % Ang,date_fmt,"%.3f" % Temp,"%.2f" % Hyg]

        #randomly evolving data
        Temp+=uniform(-5,5)
        Hyg+=uniform(-2,2)

        #
        Buffer_List[-1]=True
        i+=1

#launching thread
t1=Thread(target=wait,daemon=True)
t1.start()

#animation function
anim=animation.FuncAnimation(fig,robot.frames[Analysis_Page].animate,interval=1000)

#main thread (uses Retrieve_Data function from Robot_Veronica.py
t=Thread(target=Retrieve_Data,args=(Buffer_List,robot),daemon=True)
t.start()

#Main program loop
robot.mainloop()